/* Sweep
 by BARRAGAN <http://barraganstudio.com>
 This example code is in the public domain.

 modified 8 Nov 2013
 by Scott Fitzgerald
 http://www.arduino.cc/en/Tutorial/Sweep
*/

#include <Servo.h>
#include "LedControl.h" 
#define BackStep 5


 LedControl lc=LedControl(11,13,3,1);

Servo myservo0;  // create servo object to control a servo
Servo myservo1; 
 
// twelve servo objects can be created on most boards

int pos0 = 0,pos1 = 0,pos2 = 0,pos3 = 0,  iCount0=0,  iCount1=90,  iCount2=180,  iCount3=270;    // variable to store the servo position

byte SniFi[]= {115,115,116,116,116,115,115,115,115,114,114,114,113,113,112,111,111,110,109,108,107,106,105,104,103,102,100,99,98,96,95,94,92,91,89,87,86,84,82,81,79,77,75,73,72,70,68,66,64,62,60,58,56,54,52,49,47,45,43,40,57,113,168,166,115};



byte SniPsi[]= {144,142,140,138,136,134,133,131,129,127,126,124,122,121,119,118,116,115,113,112,110,109,107,106,104,103,102,100,99,97,96,95,93,92,91,89,88,87,86,85,83,82,81,80,79,78,77,76,75,74,73,72,72,71,70,69,69,68,68,67,35,62,99,135,144};

byte LedCh[8],iLed;
int StepDelay;
byte i,iBackStep;

void OneStep(void);

void setup() 
{
Serial.begin(9600);
Serial.println(F("StepPointerLed003"));
pinMode(A0,INPUT);

pinMode(A4,INPUT_PULLUP);

pinMode(11,OUTPUT);
pinMode(13,OUTPUT);
pinMode(3,OUTPUT);

  
  myservo0.attach(A2);  //  psi attaches the servo on pin 9 to the servo object
   myservo1.attach(A3);  // fi


  lc.shutdown(0,false);
  lc.shutdown(1,false);
  /* Set the brightness to a maximum values */
  lc.setIntensity(0,15);
  lc.setIntensity(1,15);
  
  /* and clear the display */
   lc.clearDisplay(0);
      lc.clearDisplay(1);
   
  
}

void loop() {

 

 

//delay(5+analogRead(A0)/32);
if(0)
{
 Serial.print(i);
  Serial.print("  \t");
 
  Serial.print(pos1);
  Serial.print("  \t");
  Serial.print(pos0);
 Serial.print("  \t Delay=");
  Serial.println(StepDelay);

}

if( (PINC&0x10)==0x10)
{
pos0=(1023-analogRead(A0))/5;
pos1=(1023-analogRead(A1))/5;

  myservo0.write(pos0);              // tell servo to go to position in variable 'pos'
     myservo1.write(pos1); 

LedCh[0]=pos1%10;
LedCh[1]=(pos1/10)%10;
LedCh[2]=pos1/100;

LedCh[4]=pos0%10;
LedCh[5]=(pos0/10)%10;
LedCh[6]=pos0/100;



 lc.setChar(0,4,LedCh[0],false);
lc.setChar(0,5,LedCh[1],false);
lc.setChar(0,6,LedCh[2],false);
//lc.setChar(0,7,LedCh[3],false);

lc.setChar(0,0,LedCh[4],false);
lc.setChar(0,1,LedCh[5],false);
lc.setChar(0,2,LedCh[6],false);
 //lc.setChar(0,3,LedCh[7],false);
 delay(100);


     
}
else



{

 OneStep();
 
 
    StepDelay=analogRead(A5);
    if (StepDelay<10)
    StepDelay=0;
       delay(StepDelay);
}
}

void OneStep(void)
{

  pos1=SniFi[i];
pos0=SniPsi[i];

  myservo0.write(pos0);              // tell servo to go to position in variable 'pos'
     myservo1.write(pos1); 

if(i>59)
{
if((iBackStep++>BackStep  )       || ( StepDelay>5)       )
{
i++;
iBackStep=0;

}
}
else
i++;


if(i>64)
i=0;

LedCh[0]=pos1%10;
LedCh[1]=(pos1/10)%10;
LedCh[2]=pos1/100;

LedCh[4]=pos0%10;
LedCh[5]=(pos0/10)%10;
LedCh[6]=pos0/100;



 lc.setChar(0,4,LedCh[0],false);
lc.setChar(0,5,LedCh[1],false);
lc.setChar(0,6,LedCh[2],false);
//lc.setChar(0,7,LedCh[3],false);

lc.setChar(0,0,LedCh[4],false);
lc.setChar(0,1,LedCh[5],false);
lc.setChar(0,2,LedCh[6],false);
 //lc.setChar(0,3,LedCh[7],false);

   

}


